#### Linux From Scratch - Version 9.0-systemd

### Chapter 6. Installing Basic System Software

- Prev

  Vim-8.1.1846

- Next

  D-Bus-1.12.16

- Up
- Home

# 6.72. Systemd-241

The systemd package contains programs for controlling the startup, running, and shutdown of the system.

Approximate build time: 0.4 SBU
Required disk space: 227 MB

## 6.72.1. Installation of systemd

First, apply a patch to fix issues with systemd-networkd on Linux 5.2+ kernels, as well as with AMD Ryzen CPUs:

    patch -Np1 -i ../systemd-241-networkd_and_rdrand_fixes-1.patch

Create a symlink to work around missing xsltproc:

    ln -sf /tools/bin/true /usr/bin/xsltproc

Because we have not yet installed the final version of Util-Linux, create links to the libraries in the approprite location:

    for file in /tools/lib/lib{blkid,mount,uuid}.so*; do
        ln -sf $file /usr/lib/
    done

Set up the man pages:

    tar -xf ../systemd-man-pages-241.tar.xz

Remove tests that cannot be built in chroot:

    sed '177,$ d' -i src/resolve/meson.build

Remove an unneeded group, `render`, from the default udev rules:

    sed -i 's/GROUP="render", //' rules/50-udev-default.rules.in

Prepare systemd for compilation:

    mkdir -p build
    cd       build

    PKG_CONFIG_PATH="/usr/lib/pkgconfig:/tools/lib/pkgconfig" \
    LANG=en_US.UTF-8                   \
    CFLAGS+="-Wno-format-overflow"     \
    meson --prefix=/usr                \
          --sysconfdir=/etc            \
          --localstatedir=/var         \
          -Dblkid=true                 \
          -Dbuildtype=release          \
          -Ddefault-dnssec=no          \
          -Dfirstboot=false            \
          -Dinstall-tests=false        \
          -Dkmod-path=/bin/kmod        \
          -Dldconfig=false             \
          -Dmount-path=/bin/mount      \
          -Drootprefix=                \
          -Drootlibdir=/lib            \
          -Dsplit-usr=true             \
          -Dsulogin-path=/sbin/sulogin \
          -Dsysusers=false             \
          -Dumount-path=/bin/umount    \
          -Db_lto=false                \
          -Drpmmacrosdir=no            \
          ..

The meaning of the meson options:

`-D*-path=*`

  These switches provide location of binaries needed by systemd at runtime that have not yet been installed, or who's pkgconfig files are currently only in `/tools/lib/pkgconfig`.

`-Ddefault-dnssec=no`

  This switch turns off the experimental DNSSEC support.

`-Dfirstboot=false`

  This switch prevents installation of systemd services responsible for setting up the system for the first time. They are not useful for LFS because everything is done manually.

`-Dinstall-tests=false`

  This switch prevents installation of the compiled tests.

`-Dldconfig=false`

  This switch prevents installation of a systemd unit that runs ldconfig at boot, which is not useful for source distributions such as LFS and makes the boot time longer. Remove it if the described feature is desired.

`-Droot*`

  These switches ensure that core programs and shared libraries are installed in the subdirectories of the root partition.

`-Dsplit-usr=true`

  This switch ensures that systemd will work on systems where /bin, /lib and /sbin directories are not symlinks to their /usr counterparts.

`-Dsysusers=false`

  This switch prevents installation of systemd services responsible for setting up the `/etc/group` and `/etc/passwd` files. Both files were created earlier in this chapter.

`-Drpmmacrosdir=no`

  This switch disables installation of RPM Macros for use with systemd because LFS does not support RPM.

Compile the package:

    LANG=en_US.UTF-8 ninja

Install the package:

    LANG=en_US.UTF-8 ninja install

Remove an unnecessary symbolic link:

    rm -f /usr/bin/xsltproc

Create the `/etc/machine-id` file needed by systemd-journald:

    systemd-machine-id-setup

Remove symbolic links to Util-Linux libraries:

    rm -fv /usr/lib/lib{blkid,uuid,mount}.so*

Prevent systemd from creating `/run/nologin` to allow unprivileged user logins without systemd-logind:

    rm -f /usr/lib/tmpfiles.d/systemd-nologin.conf

## 6.72.2. Contents of systemd

Installed programs: bootctl, busctl, coredumpctl, halt (symlink to systemctl), hostnamectl, init, journalctl, kernel-install, localectl, loginctl, machinectl, networkctl, portablectl, poweroff (symlink to systemctl), reboot (symlink to systemctl), resolvconf (symlink to resolvectl), resolvectl, runlevel (symlink to systemctl), shutdown (symlink to systemctl), systemctl, systemd-analyze, systemd-ask-password, systemd-cat, systemd-cgls, systemd-cgtop, systemd-delta, systemd-detect-virt, systemd-escape, systemd-hwdb, systemd-id128, systemd-inhibit, systemd-machine-id-setup, systemd-mount, systemd-notify, systemd-nspawn, systemd-path, systemd-resolve (symlink to resolvectl), systemd-run, systemd-socket-activate, systemd-stdio-bridge, systemd-tmpfiles, systemd-tty-ask-password-agent, systemd-umount (symlink to systemd-mount), telinit (symlink to systemctl), timedatectl, and udevadm
Installed libraries: libnss_myhostname.so.2, libnss_mymachines.so.2, libnss_resolve.so.2, libnss_systemd.so.2, libsystemd.so, libsystemd-shared-241.so (in /lib/systemd), and libudev.so
Installed directories: /etc/binfmt.d, /etc/init.d, /etc/kernel, /etc/modules-load.d, /etc/sysctl.d, /etc/systemd, /etc/tmpfiles.d, /etc/udev, /etc/xdg/systemd, /lib/systemd, /lib/udev, /usr/include/systemd, /usr/lib/binfmt.d, /usr/lib/kernel, /usr/lib/modules-load.d, /usr/lib/sysctl.d, /usr/lib/systemd, /usr/lib/tmpfiles.d, /usr/share/doc/systemd-241, /usr/share/factory, /usr/share/systemd, /var/lib/systemd, and /var/log/journal

### Short Descriptions

bootctl | Used to query the firmware and boot manager settings
busctl | Used to introspect and monitor the D-Bus bus
coredumpctl | Used to retrieve coredumps from the systemd journal
halt | Normally invokes shutdown with the `-h` option, except when already in run-level 0, then it tells the kernel to halt the system; it notes in the file `/var/log/wtmp` that the system is being brought down
hostnamectl | Used to query and change the system hostname and related settings
init | The first process to be started when the kernel has initialized the hardware which takes over the boot process and starts all processes according to its configuration files
journalctl | Used to query the contents of the systemd journal
kernel-install | Used to add and remove kernel and initramfs images to and from /boot
localectl | Used to query and change the system locale and keyboard layout settings
loginctl | Used to introspect and control the state of the systemd Login Manager
machinectl | Used to introspect and control the state of the systemd Virtual Machine and Container Registration Manager
networkctl | Used to introspect the state of the network links as seen by systemd-networkd
portablectl | Used to attach or detach portable services from the local system
poweroff | Tells the kernel to halt the system and switch off the computer (see halt)
reboot | Tells the kernel to reboot the system (see halt)
resolvconf | Register DNS server and domain configuration with systemd-resolved
resolvectl | Send control commands to the network name resolution manager, or resolve domain names, IPv4 and IPv6 addresses, DNS records, and services.
runlevel | Reports the previous and the current run-level, as noted in the last run-level record in `/var/run/utmp`
shutdown | Brings the system down in a secure way, signaling all processes and notifying all logged-in users
systemctl | Used to introspect and control the state of the systemd system and service manager
systemd-analyze | Used to determine system boot-up performance of the current boot
systemd-ask-password | Used to query a system password or passphrase from the user, using a question message specified on the command line
systemd-cat | Used to connect STDOUT and STDERR of a process with the Journal
systemd-cgls | Recursively shows the contents of the selected Linux control group hierarchy in a tree
systemd-cgtop | Shows the top control groups of the local Linux control group hierarchy, ordered by their CPU, memory and disk I/O load
systemd-delta | Used to identify and compare configuration files in `/etc` that override default counterparts in `/usr`
systemd-detect-virt | Detects execution in a virtualized environment
systemd-escape | Used to escape strings for inclusion in systemd unit names
systemd-hwdb | Used to manage hardware database (hwdb)
systemd-id128 | Generate and print id128 strings
systemd-inhibit | Used to execute a program with a shutdown, sleep or idle inhibitor lock taken
systemd-machine-id-setup | Used by system installer tools to initialize the machine ID stored in `/etc/machine-id` at install time with a randomly generated ID
systemd-mount | A tool to temporarily mount or auto-mount a drive.
systemd-notify | Used by daemon scripts to notify the init system about status changes
systemd-nspawn | Used to run a command or OS in a light-weight namespace container
systemd-path | Used to query system and user paths
systemd-resolve | Used to resolve domain names, IPV4 and IPv6 addresses, DNS resource records, and services
systemd-run | Used to create and start a transient .service or a .scope unit and run the specified command in it
systemd-socket-activate | A tool to listen on socket devices and launch a process upon connection.
systemd-tmpfiles | Creates, deletes and cleans up volatile and temporary files and directories, based on the configuration file format and location specified in `tmpfiles.d` directories
systemd-umount | Unmount mount points
systemd-tty-ask-password-agent | Used to list or process pending systemd password requests
telinit | Tells init which run-level to change to
timedatectl | Used to query and change the system clock and its settings
udevadm | Generic udev administration tool: controls the udevd daemon, provides info from the Udev database, monitors uevents, waits for uevents to finish, tests udev configuration, and triggers uevents for a given device
`libsystemd` | The main systemd utility library
`libudev` | A library to access Udev device information

- Prev

  Vim-8.1.1846

- Next

  D-Bus-1.12.16

- Up
- Home